/*
**  ContentIndexer.h
**
**  Copyright (c) 2004
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __ContentIndexer__
#define __ContentIndexer__

#include <AppKit/AppKit.h>

@interface ContentIndexer : NSObject
{
  IBOutlet id removeIndexButton;
  IBOutlet id indexLocationLabel;
  IBOutlet id indexPanel;
  IBOutlet id mknmzTextField;
  IBOutlet id namazuTextField;
  IBOutlet id rebuildProgressIndicator, removeProgressIndicator;
  IBOutlet id rebuildLabel, removeLabel;

  NSString *mknmzLocation, *namazuLocation, *indexLocation;

  /* Cache */
  NSString *cachePattern;
  NSMutableArray *cacheFiles;
}

- (void) makeIndexerKeyAndOrderFront: (id)sender;
- (void) setIndexLocation: (NSString *) absolutePath;
- (NSArray *) filesContain: (NSString *) pattern;

- (IBAction)mknmzFindButtonAction:(id)sender;
- (IBAction)mknmzLocationTextFieldAction:(id)sender;
- (IBAction)namazuFindButtonAction:(id)sender;
- (IBAction)namazuLocationTextFieldAction:(id)sender;
- (IBAction)rebuildContentIndexButtonAction:(id)sender;
- (IBAction)removeContentIndexButtonAction:(id)sender;
- (IBAction)namazuButtonAction:(id)sender;

+ (ContentIndexer *) sharedIndexer;
@end

#endif /* __ContentIndexer__ */
