/*
**  SearchSource.m
**
**  Copyright (c) 2004
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "SearchSource.h"
#include "Criterion.h"

@implementation SearchSource

- (void) becomeSmartFolder: (BOOL) flag
{
  if (isSmartFolder == YES) return;
  isSmartFolder = flag;
}

- (void) setCriterion: (Criterion *) c
{
  if (isSmartFolder == YES) return;
  [criterion setCriterion: c];
  /* always match all */
  [criterion setMatchAll: YES];
}

- (id) init
{
  self = [super init];
  isSmartFolder = NO;
}

@end
