/*
**  SmartFolderEditor.h
**
**  Copyright (c) 2004
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __SmartFolderEditor__
#define __SmartFolderEditor__

#include <AppKit/AppKit.h>

@class Criterion;

@interface SmartFolderEditor: NSObject
{
  IBOutlet id matchAllButton;
  IBOutlet id criterionView;
  IBOutlet id editor;
  IBOutlet id numberPopUpButton;
  IBOutlet id datePopUpButton;

  Criterion *criterion, *original;
  NSString *title;
}

+ (id) sharedEditor;

- (void) okAction: (id) sender;
- (void) cancelAction: (id) sender;
- (void) numberPopUpButtonAction: (id) sender;
- (void) datePopUpButtonAction: (id) sender;
- (void) matchAllButtonAction: (id) sender;

- (void) makeEditorKeyAndOrderFront: (id) sender;

- (void) setTitle: (NSString *) title;
- (void) setCriterion: (Criterion *) criterion;
- (Criterion *) criterion;

@end

#endif /* __SmartFolderEditor__ */
