/*
**  SummaryViewer.h
**
**  Copyright (c) 2004
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __SummaryViewer__
#define __SummaryViewer__

#include <AppKit/AppKit.h>
#include "Constants.h"

@interface SummaryViewer : NSObject
{
  IBOutlet id textView;
  IBOutlet id viewer;

  id delegate;
  SummaryStyle style;
}

+ (id) sharedViewer;
- (void) makeViewerKeyAndOrderFront: (id) sender;

- (IBAction)summaryStyleAction:(id)sender;

- (void) setSummary: (NSAttributedString *) summary;
- (SummaryStyle) summaryStyle;
- (void) setTitle: (NSString *) title;
- (void) setDelegate: (id) delegate;
- (id) delegate;

@end

@interface NSObject (SummaryViewerDelegate)
- (void) styleDidChangeInSummaryViewer: (id) viewer;
@end

#endif /* SummaryViewer */
